<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2005 DanSoft Australia           |
|      http://www.dansoftaus.uni.cc/           |
\**********************************************/

//File: Shop.php
//      The main shop file

//VERSION: 2.0 (Build 8)
//DATE: 28th December 2005

if (!defined('SMF'))
	die('Hacking attempt...');

function Shop(){
	//global $db_prefix, $context, $scripturl, $user_info, $txt, $modSettings, $ID_MEMBER, $themeUser;

    global $context, $modSettings, $scripturl, $db_prefix, $ID_MEMBER, $txt, $item_info, $boardurl;
    
    //during testing, caching was causing many problems. So, we try to disable the caching
    //here.
    header("Expires: Fri, 1 Jun 1990 00:00:00 GMT"); //my birthday ;)
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    header("Pragma: no-cache");

    loadLanguage('Shop');
    //check if guest is trying to access
    is_not_guest($txt['shop_guest_message']);
    //loadTemplate('Shop');

    $context['page_title'] = $txt['shop'];
    $context['linktree'][] = array(
        'url' => "$scripturl?action=shop",
        'name' => $txt['shop'],
		);

    //This needs to be here to fix the problem of the 'Bank' link disappearing when on any
    //page other than the index
    if ($modSettings['shopBankEnabled']) {
        $context['shop_bank_link'] = "<a href='$scripturl?action=shop;do=bank'>{$txt['shop_bank']}</a><br>";
    } else {
        $context['shop_bank_link'] = "";
    }
	
	//If trade centre disabled, don't show it.
	$context['shop_trade_link'] = ($modSettings['shopTradeEnabled']) ? "<a href='$scripturl?action=shop;do=trade'>{$txt['shop_trade']}</a> *NEW*<br />" : "";

    if (empty($_GET['do']) || $_GET['do'] == "home") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop",
            'name' => "{$txt['shop']} Home",
        ); 

        //10 richest people (pocket)
        $context['shop_richest'] = "";
        $result = db_query("SELECT realName, money
                            FROM {$db_prefix}members
                            ORDER BY money DESC, realName
                            LIMIT 10", __FILE__, __LINE__);
        
        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_richest'] .= "<b>{$row['realName']}</b> - ".formatMoney($row['money'])."<br>\r\n";
        }

        //10 richest people (pocket)
        $context['shop_richestBank'] = "";
        $result = db_query("SELECT realName, moneyBank
                            FROM {$db_prefix}members
                            ORDER BY moneyBank DESC, realName
                            LIMIT 10", __FILE__, __LINE__);
        
        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_richestBank'] .= "<b>{$row['realName']}</b> - ".formatMoney($row['moneyBank'])."<br>\r\n";
        }

        $context['shop_newtopic'] = formatMoney($modSettings['shopPointsPerTopic']);
        $context['shop_newpost'] = formatMoney($modSettings['shopPointsPerPost']);

        //member's money
        $result = db_query("SELECT money, moneyBank
                            FROM {$db_prefix}members
                            WHERE ID_MEMBER = $ID_MEMBER
                            LIMIT 1", __FILE__, __LINE__);
        
        $row = mysql_fetch_array($result, MYSQL_ASSOC);

        $context['shop_money'] = formatMoney($row['money']);
        $context['shop_money_bank'] = formatMoney($row['moneyBank']);
        
		if ($modSettings['shopBankEnabled']) {
			$context['shop_bank_info'] = "<br><b>{$txt['shop_bankinterest']}: </b>{$modSettings['shopInterest']}% per day<br>";
			$context['shop_money_in_bank'] = "<b>{$txt['shop_money_in_bank']}: </b>{$context['shop_money_bank']}";
	
		} else {
			$context['shop_bank_info'] = "";
			$context['shop_money_in_bank'] = "";
		}
		
		$context['sub_template'] = "main";
		loadTemplate('Shop');

    } elseif ($_GET['do'] == "buy") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=buy",
            'name' => $txt['shop_buy'],
        );

        $context['shop_items_list'] = "
<tr valign='top' class='windowbg'>
    <td style='padding-bottom: 2ex;' width='32'>
        <b>{$txt['shop_image']}</b>
    </td>
    <td>
        <b>{$txt['shop_name']}</b>
    </td>
    <td>
        <b>{$txt['shop_description']}</b>
    </td>
    <td width='18%'>
        <b>{$txt['shop_price']}/{$txt['shop_stock']}</b>
    </td>
</tr>";


        $result = db_query("SELECT money
                            FROM {$db_prefix}members
                            WHERE ID_MEMBER = $ID_MEMBER
                            LIMIT 1", __FILE__, __LINE__);
        
        $row = mysql_fetch_array($result, MYSQL_ASSOC);
        $usersmoney = $row['money'];

        $alternating = "windowbg2";
        $result = db_query("SELECT name, `desc`, price, stock, id, image
                            FROM {$db_prefix}shop_items
                            ORDER BY name ASC", __FILE__, __LINE__);

        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_items_list'] .= "
<tr valign='top' class='{$alternating}'>
    <td>
        <img border='0' width='32' height='32' src='{$boardurl}/Sources/shop/item_images/{$row['image']}'>
    </td>
    <td style='padding-bottom: 2ex;' width='20%'>
        {$row['name']}
    </td>
    <td>
        {$row['desc']}
    </td>
    <td width='18%'>
        {$txt['shop_price']}: {$row['price']}<br>
        {$txt['shop_stock']}: {$row['stock']}<br>";

            if ($usersmoney >= $row['price']) {
                $context['shop_items_list'] .= "<a href='$scripturl?action=shop;do=buy2;id={$row['id']}'>{$txt['shop_buynow']}</a>";
            } elseif ($row['stock'] == 0) {
                $context['shop_items_list'] .= "<b>{$txt['shop_soldout']}</b>";
            } else {
                $context['shop_items_list'] .= "<b>".sprintf($txt['shop_need'], formatMoney($row['price'] - $usersmoney))."</b>";
            }

            $context['shop_items_list'] .= "</td></tr>";

            if ($alternating == "windowbg") {
                $alternating = "windowbg2";
            } else {
                $alternating = "windowbg";
            }
        } 
		
		$context['sub_template'] = "inventory";
		loadTemplate('Shop');
    } elseif ($_GET['do'] == "buy2") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=buy",
            'name' => $txt['shop_buy'],
        );

        //user's money
        $result = db_query("SELECT money
                            FROM {$db_prefix}members
                            WHERE ID_MEMBER = {$ID_MEMBER}
                            LIMIT 1", __FILE__, __LINE__);
        
        $row = mysql_fetch_array($result, MYSQL_ASSOC);
        $usersmoney = $row['money'];

        //item information
        $result = db_query("SELECT price, stock, name
                            FROM {$db_prefix}shop_items
                            WHERE id = {$_GET['id']}
                            LIMIT 1", __FILE__, __LINE__);
        $row = mysql_fetch_array($result, MYSQL_ASSOC);


        if ($usersmoney < $row['price']) {
            $context['shop_buy_message'] = sprintf($txt['shop_not_enough_money'], $cost - $usersmoney);
        } elseif ($row['stock'] == 0) {
            $context['shop_buy_message'] = $txt['shop_soldout_full'];
        } else {

            //put item in user's inventory
            $result = db_query("INSERT
                                INTO {$db_prefix}shop_inventory
                                (ownerid, itemid, amtpaid)
                                VALUES (
                                        {$ID_MEMBER},
                                        {$_GET['id']},
                                        {$row['price']})",
                                        __FILE__, __LINE__);

            //decrease user's money
            $result = db_query("UPDATE {$db_prefix}members
                                SET money = money - {$row['price']}
                                WHERE ID_MEMBER = {$ID_MEMBER}
                                LIMIT 1",
                                __FILE__, __LINE__);

            //decrease stock by 1
            $result = db_query("UPDATE {$db_prefix}shop_items
                                SET stock = stock - 1
                                WHERE id = {$_GET['id']}
                                LIMIT 1",
                                __FILE__, __LINE__);

            $context['shop_buy_message'] = sprintf($txt['shop_bought_item'], $row['name']);
        }
		
		$context['sub_template'] = "message";
		loadTemplate('Shop');

    } elseif ($_GET['do'] == "inv") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=inv",
            'name' => $txt['shop_yourinv'],
        );

		$context['shop_items_list'] = "
<tr valign='top' class='windowbg'>
    <td style='padding-bottom: 2ex;' width='32'>
        <b>{$txt['shop_image']}</b>
    </td>
    <td>
        <b>{$txt['shop_name']}</b>
    </td>
    <td>
        <b>{$txt['shop_description']}</b>
    </td>
    <td width='18%'>
        <b>Paid/Use</b>
    </td>
</tr>";

        $alternating = "windowbg2";

        $result = db_query("SELECT it.name, it.desc, it.input_needed, it.can_use_item, it.image,
                                   inv.amtpaid, inv.id, inv.trading, inv.tradecost
                            FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
                            WHERE inv.ownerid = {$ID_MEMBER} AND inv.itemid = it.id",
                            __FILE__, __LINE__);

        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_items_list'] .= "
<tr valign='top' class='{$alternating}'>
    <td>
        <img border='0' width='32' height='32' src='{$boardurl}/Sources/shop/item_images/{$row['image']}'>
    </td>
    <td style='padding-bottom: 2ex;' width='20%'>
        {$row['name']}
    </td>
    <td>
        {$row['desc']}
    </td>
    <td width='18%'>
        Paid: {$row['amtpaid']}<br>";


            //order of if's is IMPORTANT here!
			if ($row['trading'] == 1) {
				$context['shop_items_list'] .= "<i>".sprintf($txt['shop_trading'], formatMoney($row['tradecost']))."</i><br><a href='$scripturl?action=shop;do=trade_stop;id={$row['id']}'>{$txt['shop_stoptrade']}</a>";
			} else {
				if ($row['can_use_item'] == false) {
					$context['shop_items_list'] .= "<b>{$txt['shop_unusable']}</b>";
				} elseif ($row['input_needed'] == false) {
					$context['shop_items_list'] .= "<a href='{$scripturl}?action=shop;do=inv3;id={$row['id']}'>{$txt['shop_use']}</a>";
				} else {
					$context['shop_items_list'] .= "<a href='{$scripturl}?action=shop;do=inv2;id={$row['id']}'>{$txt['shop_use']}</a>";
				}
				
				if ($modSettings['shopTradeEnabled'])
					$context['shop_items_list'] .= "<br><a href='{$scripturl}?action=shop;do=trade_sell;id={$row['id']}'>{$txt['shop_tradeitem']}</a>";
            }

            $context['shop_items_list'] .= "</td></tr>";

            if ($alternating == "windowbg") {
                $alternating = "windowbg2";
            } else {
                $alternating = "windowbg";
            }
        }
		
		$context['sub_template'] = "inventory";
		loadTemplate('Shop');
		
    } elseif ($_GET['do'] == "inv2") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=inv",
            'name' => $txt['shop_yourinv'],
        );
		
        $result = db_query("SELECT it.module, it.can_use_item, it.info1, it.info2, it.info3,
                                   it.info4, inv.ownerid
                            FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
                            WHERE inv.id = {$_GET['id']} AND inv.itemid = it.id
                            LIMIT 1", __FILE__, __LINE__);

        $row = mysql_fetch_array($result, MYSQL_ASSOC);
        if ($row['ownerid'] !== $ID_MEMBER) { //trying to steal other person's item
            die($txt['shop_use_others_item']);
        } elseif ($row['can_use_item'] == false) {
            die($txt['shop_unusable']);
        }

        $context['shop_buy_message'] = "{$txt['shop_input']}<br>
             <form action='$scripturl?action=shop;do=inv3;id={$_GET['id']}' method='POST'>";


        //additional info, just in case it's needed in getUseInput() function
        $item_info[1] = $row['info1'];
        $item_info[2] = $row['info2'];
        $item_info[3] = $row['info3'];
        $item_info[4] = $row['info4'];

        require("Sources/shop/item_engine.php");
        require("Sources/shop/items/{$row['module']}.php");
        eval("\$temp = new item_{$row['module']};");
        $context['shop_buy_message'] .= $temp->getUseInput();
        $context['shop_buy_message'] .= "<br><input type='submit' value='{$txt['shop_use']}'></form>";
		
		$context['sub_template'] = "message";
		loadTemplate('Shop');
			
    } elseif ($_GET['do'] == "inv3") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=inv",
            'name' => $txt['shop_yourinv'],
        );

        $result = db_query("SELECT it.module, it.can_use_item, it.info1, it.info2, it.info3,
                                   it.info4, inv.ownerid
                            FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
                            WHERE inv.id = {$_GET['id']} AND inv.itemid = it.id
                            LIMIT 1", __FILE__, __LINE__);

        $row = mysql_fetch_array($result, MYSQL_ASSOC);
        if ($row['ownerid'] !== $ID_MEMBER) { //trying to steal other person's item
            die($txt['shop_use_others_item2']);
        } elseif ($row['can_use_item'] == false) {
            die($txt['shop_unusable']);
        }

        //additional info
        $item_info[1] = $row['info1'];
        $item_info[2] = $row['info2'];
        $item_info[3] = $row['info3'];
        $item_info[4] = $row['info4'];

        require("Sources/shop/item_engine.php");
        require("Sources/shop/items/{$row['module']}.php");

        eval("\$temp = new item_{$row['module']};");
        $context['shop_buy_message'] = $temp->onUse();
        $context['shop_buy_message'] .= "<br><br><a href='$scripturl?action=shop;do=inv'>{$txt['shop_back2inv']}</a>";

        $result = db_query("DELETE FROM {$db_prefix}shop_inventory
                            WHERE id = {$_GET['id']}", 
                            __FILE__, __LINE__);
							
		$context['sub_template'] = "message";
		loadTemplate('Shop');
    } elseif($_GET['do'] == "sendmoney") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=sendmoney",
            'name' => $txt['shop_send_money'],
        );

        $context['sub_template'] = "sendmoney";
		loadTemplate('Shop');
		
    } elseif($_GET['do'] == "sendmoney2") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=sendmoney",
            'name' => $txt['shop_send_money'],
        );

        $amount = (int) $_POST['amount']; //convert amount to integer

        $result = db_query("SELECT money, memberName
                            FROM {$db_prefix}members
                            WHERE ID_MEMBER = {$ID_MEMBER}
                            LIMIT 1", __FILE__, __LINE__);

        $row = mysql_fetch_array($result, MYSQL_ASSOC);
        $membersName = $row['memberName'];

        if ($row['money'] < $amount) { //trying to give more than they have
            $context['shop_buy_message'] = $txt['shop_dont_have_much'];
        } elseif ($amount < 0) { //trying to give a negative amount(stealing)
            $context['shop_buy_message'] = $txt['shop_give_negative'];
        } elseif ($amount == 0) { //trying to give 0 (either typed 0, or non-numeric string)
            $context['shop_buy_message'] = $txt['shop_invalid_send_amount'];
        } else {
            //get the id and email of member to send to
            $result = db_query("SELECT ID_MEMBER, memberName, emailAddress
                                FROM {$db_prefix}members
                                WHERE memberName = '{$_POST['membername']}'
                                LIMIT 1", __FILE__, __LINE__);
            $row = mysql_fetch_array($result, MYSQL_ASSOC);
            
            if ($row['memberName'] !== $_POST['membername']) {
                $context['shop_buy_message'] = sprintf($txt['shop_member_no_exist'], $_POST['membername']);
            } else {
                //take money off sender
                $result = db_query("UPDATE {$db_prefix}members
                                    SET money = money - {$amount}
                                    WHERE ID_MEMBER = {$ID_MEMBER}
                                    LIMIT 1", __FILE__, __LINE__);

                //give money to receiver
                $result = db_query("UPDATE {$db_prefix}members
                                    SET money = money + {$amount}
                                    WHERE ID_MEMBER = {$row['ID_MEMBER']}
                                    LIMIT 1", __FILE__, __LINE__);
                                    
             $to = $row['emailAddress'];
             $subject = formatMoney($amount)." sent to you by $membersName";
             $message = "$membersName has sent you ".formatMoney($amount).". If they left a message explaining why, it will be below:\r\n\r\n {$_POST['message']}\r\nHave a good day,\r\n --Forum Management";
             mail($to, $subject, $message);

             $context['shop_buy_message'] = sprintf($txt['shop_successfull_send'], formatMoney($amount), $row['memberName']);
            }
        }
		
		$context['sub_template'] = "message";
		loadTemplate('Shop');
		
    } elseif($_GET['do'] == "viewall") {

        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=viewall",
            'name' => $txt['shop_view_all'],
        );

        $context['shop_buy_message'] = "";
        $result = db_query("SELECT memberName, money
                            FROM {$db_prefix}members
                            WHERE money <> 0
                            ORDER BY money DESC
                            ", __FILE__, __LINE__);

        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_buy_message'] .= "<b>{$row['memberName']}</b> - ".formatMoney($row['money'])."<br>\r\n";
        }
		
		$context['sub_template'] = "message";
		loadTemplate('Shop');
    } elseif($_GET['do'] == "bank") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=bank",
            'name' => $txt['shop_bank'],
        );
        
        //get money in bank
        $result = db_query("SELECT moneyBank, money
                            FROM {$db_prefix}members
                            WHERE ID_MEMBER = $ID_MEMBER
                            LIMIT 1", __FILE__, __LINE__);
        
        $row = mysql_fetch_array($result, MYSQL_ASSOC);

        //$context['shop_money_bank'] = formatMoney($row['moneyBank']);
        //$context['shop_money_pocket'] = formatMoney($row['money']);
        $context['shop_bank_message'] = sprintf($txt['shop_current_bank'], formatMoney($row['moneyBank']), formatMoney($row['money']));
		
		$context['sub_template'] = "bank";
		loadTemplate('Shop');
		
    } elseif($_GET['do'] == "bank2") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=bank",
            'name' => $txt['shop_bank'],
        );
        
        if ($_POST['type'] == "deposit") {
            $_POST['amount'] = (int) $_POST['amount'];
            //get user's money
            $result = db_query("SELECT money
                                FROM {$db_prefix}members
                                WHERE ID_MEMBER = $ID_MEMBER
                                LIMIT 1", __FILE__, __LINE__);

            $row = mysql_fetch_array($result, MYSQL_ASSOC);
            //if user is trying to deposit more money than they have
            if ($_POST['amount'] > $row['money']) {
                $context['shop_buy_message'] = $txt['shop_dont_have_much'];
            //if trying to deposit less than 0
            } elseif ($_POST['amount'] <= 0) {
                $context['shop_buy_message'] = $txt['shop_no_negative'];
            //all is good
            } else {
                //add amount to member's bank money, and remove from money in pockey
                $result = db_query("UPDATE {$db_prefix}members
                                    SET moneyBank = moneyBank + {$_POST['amount']},
                                        money = money - {$_POST['amount']}
                                    WHERE ID_MEMBER = $ID_MEMBER
                                    LIMIT 1", __FILE__, __LINE__);

                //get current money amounts (pocket and bank)
                $result = db_query("SELECT money, moneyBank
                                    FROM {$db_prefix}members
                                    WHERE ID_MEMBER = $ID_MEMBER
                                    LIMIT 1", __FILE__, __LINE__ );
                $row = mysql_fetch_array($result, MYSQL_ASSOC);
                
                $money = formatMoney($row['money']);
                $moneyBank = formatMoney($row['moneyBank']);

                $context['shop_buy_message'] = sprintf($txt['shop_deposit'], $moneyBank, $money)."<br><a href='$scripturl?action=shop;do=bank'>{$txt['shop_back2bank']}</a>";
            }
        } elseif ($_POST['type'] == "withdraw") {
            $_POST['amount'] = (int) $_POST['amount'];
            //get user's money in bank
            $result = db_query("SELECT moneyBank
                                FROM {$db_prefix}members
                                WHERE ID_MEMBER = $ID_MEMBER
                                LIMIT 1", __FILE__, __LINE__);

            $row = mysql_fetch_array($result, MYSQL_ASSOC);
            //if user is trying to withdraw more money than they have
            if ($_POST['amount'] > $row['moneyBank']) {
                $context['shop_buy_message'] = $txt['shop_dont_have_much2'];
            //if trying to take out less than 0
            } elseif ($_POST['amount'] <= 0) {
                $context['shop_buy_message'] = $txt['shop_no_negative'];
            //all is good
            } else {
                //remove amount from member's bank money, and add to money in pockey
                $result = db_query("UPDATE {$db_prefix}members
                                    SET moneyBank = moneyBank - {$_POST['amount']},
                                        money = money + {$_POST['amount']}
                                    WHERE ID_MEMBER = $ID_MEMBER
                                    LIMIT 1", __FILE__, __LINE__);
                                    
                //get current money amounts (pocket and bank)
                $result = db_query("SELECT money, moneyBank
                                    FROM {$db_prefix}members
                                    WHERE ID_MEMBER = $ID_MEMBER
                                    LIMIT 1", __FILE__, __LINE__ );
                $row = mysql_fetch_array($result, MYSQL_ASSOC);
                
                $money = formatMoney($row['money']);
                $moneyBank = formatMoney($row['moneyBank']);

                $context['shop_buy_message'] = sprintf($txt['shop_withdraw'], $money, $moneyBank)."<br><a href='$scripturl?action=shop;do=bank'>{$txt['shop_back2bank']}</a>";
            }
        } else {
           die("hey pal, what is '{$_POST['type']}'? You trying to trick me?");
        }
		
		$context['sub_template'] = "message";
		loadTemplate('Shop');
    } elseif($_GET['do'] == "viewallBank") {

        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=viewallBank",
            'name' => $txt['shop_view_all2'],
        );

        $context['shop_buy_message'] = "";
        $result = db_query("SELECT memberName, moneyBank
                            FROM {$db_prefix}members
                            WHERE moneyBank <> 0
                            ORDER BY moneyBank DESC
                            ", __FILE__, __LINE__);

        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_buy_message'] .= "<b>{$row['memberName']}</b> - ".formatMoney($row['moneyBank'])."<br>\r\n";
        }
		
		$context['sub_template'] = "message";
		loadTemplate('Shop');
    } elseif ($_GET['do'] == "invother") { //view other member's inventory
        
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=invother",
            'name' => $txt['shop_invother'],
        );
        
        $context['sub_template'] = "otherInventory";
		loadTemplate('Shop');
		
    } elseif ($_GET['do'] == "invother2") {
    
         $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=invother",
            'name' => $txt['shop_invother'],
        );

        $result = db_query("SELECT ID_MEMBER, memberName, realName
				              FROM {$db_prefix}members
				              WHERE memberName = '{$_REQUEST['member']}'
				              LIMIT 1", __FILE__, __LINE__);
        $row = mysql_fetch_array($result, MYSQL_ASSOC);

        if (($row['ID_MEMBER'] <> $_REQUEST['member']) && $row['memberName'] <> $_REQUEST['member']) {
            die(sprintf($txt['shop_member_no_exist'], $_REQUEST['member']));
        }
        
        $usersid = $row['ID_MEMBER'];
        $usersname = $row['realName'];

        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=invother2;member={$_REQUEST['member']}",
            'name' => sprintf($txt['shop_viewing_inv'], $usersid, $usersname),
        );


        $context['shop_items_list'] = "
<tr>
   <td colspan='3'>
       <b><center>Below is a list of all the items member ID {$usersid} ({$usersname}) has:</center></b>
   </td>
</tr>
<tr valign='top' class='windowbg'>
    <td style='padding-bottom: 2ex;' width='32'>
        <b>{$txt['shop_image']}</b>
    </td>
    <td>
        <b>{$txt['shop_name']}</b>
    </td>
    <td>
        <b>{$txt['shop_description']}</b>
    </td>
</tr>";
        $alternating = "windowbg2";

        $result = db_query("SELECT it.name, it.desc, it.image, inv.id
                            FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
                            WHERE ownerid = {$usersid} AND inv.itemid = it.id",
                            __FILE__, __LINE__);

        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_items_list'] .= "
<tr valign='top' class='{$alternating}'>
    <td>
        <img border='0' width='32' height='32' src='{$boardurl}/Sources/shop/item_images/{$row['image']}'>
    </td>
    <td style='padding-bottom: 2ex;' width='20%'>
        {$row['name']}
    </td>
    <td>
        {$row['desc']}
    </td>";

            $context['shop_items_list'] .= "</td></tr>";

            if ($alternating == "windowbg") {
                $alternating = "windowbg2";
            } else {
                $alternating = "windowbg";
            }
        }
		
		$context['sub_template'] = "inventory";
		loadTemplate('Shop');
		
	} elseif ($_GET['do'] == "trade") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=trade",
            'name' => $txt['shop_trade'],
        );
		
		$result = db_query("SELECT money
					FROM {$db_prefix}members
					WHERE ID_MEMBER = $ID_MEMBER
					LIMIT 1", __FILE__, __LINE__);
        
        $row = mysql_fetch_array($result, MYSQL_ASSOC);
        $usersmoney = $row['money'];
		
		$context['shop_trade_list'] = "";
        $alternating = "windowbg2";
		
        $result = db_query("SELECT it.name, it.desc, it.image, inv.id, m.realName, inv.tradecost
                            FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it,
							     {$db_prefix}members AS m
                            WHERE inv.trading = 1 AND inv.itemid = it.id AND 
							      m.ID_MEMBER = inv.ownerid",
                            __FILE__, __LINE__);

        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			
            $context['shop_trade_list'] .= "
<tr valign='top' class='{$alternating}'>
    <td>
        <img border='0' width='32' height='32' src='{$boardurl}/Sources/shop/item_images/{$row['image']}'>
    </td>
    <td style='padding-bottom: 2ex;' width='20%'>
        {$row['name']}
    </td>
    <td>
        {$row['desc']}<br>
		<i>".sprintf($txt['shop_trade_saleby'], $row['realName'])."</i>
    </td>
    <td width='18%'>
        {$txt['shop_price']}: {$row['tradecost']}<br>";
		
			if ($usersmoney >= $row['tradecost']) {
                $context['shop_trade_list'] .= "<a href='$scripturl?action=shop;do=trade_buy;id={$row['id']}'>{$txt['shop_buynow']}</a>";
            } else {
                $context['shop_trade_list'] .= "<b>".sprintf($txt['shop_need'], formatMoney($row['tradecost'] - $usersmoney))."</b>";
            }

            $context['shop_trade_list'] .= "</td></tr>";

			$alternating = ($alternating == "windowbg") ? "windowbg2" : "windowbg";
        }
		
		$context['sub_template'] = "userTrade";
		loadTemplate('Shop');
		
	} elseif ($_GET['do'] == "trade_buy") {
		$context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=trade",
            'name' => $txt['shop_trade'],
        );

        //user's money
        $result = db_query("SELECT money, realName
                            FROM {$db_prefix}members
                            WHERE ID_MEMBER = {$ID_MEMBER}
                            LIMIT 1", __FILE__, __LINE__);
        
        $row_user = mysql_fetch_array($result, MYSQL_ASSOC);

        //item information
		$_GET['id'] = (int) $_GET['id'];
							
        $result = db_query("SELECT it.name, inv.tradecost, inv.trading, inv.ownerid, m.realName, 
								   m.emailAddress
                            FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it,
							     {$db_prefix}members AS m
                            WHERE inv.id = {$_GET['id']} AND inv.itemid = it.id
							LIMIT 1", __FILE__, __LINE__);
							
        $row_item = mysql_fetch_array($result, MYSQL_ASSOC);
		
		if ($row_item['trading'] != 1) {
			$context['shop_buy_message'] = $txt['shop_no_sale'];
        } elseif ($row_user['money'] < $row_item['tradecost']) {
            $context['shop_buy_message'] = sprintf($txt['shop_not_enough_money'], $cost - $usersmoney);
        } else {
            //change item info (owner, amount paid, trading = not anymore)
            $result = db_query("UPDATE {$db_prefix}shop_inventory
                                SET ownerid = {$ID_MEMBER}, amtpaid = {$row_item['tradecost']},
								    trading = 0
								WHERE id = {$_GET['id']}
								LIMIT 1", __FILE__, __LINE__);
								
            //decrease user's money
            $result = db_query("UPDATE {$db_prefix}members
                                SET money = money - {$row_item['tradecost']}
                                WHERE ID_MEMBER = {$ID_MEMBER}
                                LIMIT 1", __FILE__, __LINE__);
								
			//give money to old owner
			$result = db_query("UPDATE {$db_prefix}members
								SET money = money + {$row_item['tradecost']}
								WHERE ID_MEMBER = {$row_item['ownerid']}
								LIMIT 1", __FILE__, __LINE__);
				
			//Send message to original owner				
			$to = $row_item['emailAddress'];
			$subject = "Your trade of '{$row_item['name']}' item";
			$message = "Congratulations! {$row_user['realName']} has purchased your '{$row_item['name']}' item from you for ".formatMoney($row_item['tradecost']).".\r\n\r\nHave a good day,\r\n --Forum Management";
			mail($to, $subject, $message);
				
				$context['shop_buy_message'] = sprintf($txt['shop_trade_bought_item'], $row_item['name'], $row_item['realName']);
        }
		
		
		$context['sub_template'] = "message";
		loadTemplate('Shop');
	} elseif ($_GET['do'] == "trade_sell") {
		$context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=inv",
            'name' => $txt['shop_yourinv'],
        );
		
		$_GET['id'] = (int) $_GET['id'];	
		$result = db_query("SELECT amtpaid
							FROM {$db_prefix}shop_inventory
							WHERE id = {$_GET['id']}", __FILE__, __LINE__);
		$row = mysql_fetch_array($result, MYSQL_ASSOC);
		$context['shop_paid'] = $row['amtpaid'];
		
		$context['sub_template'] = "tradeItem";
		loadTemplate('Shop');
		
	} elseif ($_GET['do'] == "trade_sell2") {
		$context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=inv",
            'name' => $txt['shop_yourinv'],
        );
		
		$_POST['id'] = (int) $_POST['id'];
		$_POST['sellfor'] = (int) $_POST['sellfor'];
        $result = db_query("SELECT ownerid
                            FROM {$db_prefix}shop_inventory
                            WHERE id = {$_POST['id']}
                            LIMIT 1", __FILE__, __LINE__);

        $row = mysql_fetch_array($result, MYSQL_ASSOC);
        if ($_POST['sellfor'] <= 0) {
			$context['shop_buy_message'] = $txt['shop_trade_negative'];
		} elseif ($row['ownerid'] !== $ID_MEMBER) { //trying to steal other person's item
            $context['shop_buy_message'] = $txt['shop_use_others_item'];
        } else {
			$result = db_query("UPDATE {$db_prefix}shop_inventory
								SET trading = 1, 
								    tradecost = {$_POST['sellfor']}
								WHERE id = {$_POST['id']}
								LIMIT 1", __FILE__, __LINE__);
			$context['shop_buy_message'] = $txt['shop_trade_success'];
			
		$context['sub_template'] = "message";
		loadTemplate('Shop');
        }
		
	} elseif ($_GET['do'] == "trade_stop") {
		$context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=inv",
            'name' => $txt['shop_yourinv'],
        );
		
		$_GET['id'] = (int) $_GET['id'];
        $result = db_query("SELECT ownerid
                            FROM {$db_prefix}shop_inventory
                            WHERE id = {$_GET['id']}
                            LIMIT 1", __FILE__, __LINE__);

        $row = mysql_fetch_array($result, MYSQL_ASSOC);
		if ($row['ownerid'] !== $ID_MEMBER) { //trying to steal other person's item
            $context['shop_buy_message'] = $txt['shop_use_others_item'];
        } else {
			$result = db_query("UPDATE {$db_prefix}shop_inventory
								SET trading = 0, tradecost = 0
								WHERE id = {$_GET['id']}
								LIMIT 1", __FILE__, __LINE__);
			$context['shop_buy_message'] = $txt['shop_trade_cancelled'];
        }

		$context['sub_template'] = "message";
		loadTemplate('Shop');
		
    } else {
        die("What do I do with {$_GET['do']}? HUH????");
    }
}

function formatMoney($money) {
    global $modSettings;

    $money = (int) $money;
    return $modSettings['shopCurrencyPrefix'].$money.$modSettings['shopCurrencySuffix'];
}
?>
